Index: libstdc++-v3/testsuite/23_containers/vector/cons/89164.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/cons/89164.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/23_containers/vector/cons/89164.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,40 @@
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-do compile { target c++11 } }
+
+#include <vector>
+
+// PR libstdc++/89164
+
+struct X
+{
+  X() = default;
+  X(const X&) = delete;
+};
+
+void test01()
+{
+  X x[1];
+  // Should not be able to create vector using uninitialized_copy:
+  std::vector<X> v1{x, x+1};	// { dg-error "here" }
+
+  // Should not be able to create vector using uninitialized_fill_n:
+  std::vector<X> v2{2u, X{}};	// { dg-error "here" }
+}
+// { dg-error "constructible from value" "" { target *-*-* } 0 }
+// { dg-error "constructible from input" "" { target *-*-* } 0 }
Index: libstdc++-v3/testsuite/23_containers/vector/cons/89164_c++17.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/cons/89164_c++17.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/23_containers/vector/cons/89164_c++17.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,50 @@
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++17" }
+// { dg-do compile { target c++17 } }
+
+#include <vector>
+
+// PR libstdc++/89164
+
+struct X
+{
+  X() = default;
+  X(const X&) = delete;
+};
+
+void test01()
+{
+  X x[1];
+  // Should not be able to create vector using uninitialized_copy:
+  std::vector<X> v1{x, x+1};	// { dg-error "here" }
+
+  // Should not be able to create vector using uninitialized_fill_n:
+  std::vector<X> v2{2u, X{}};	// { dg-error "here" }
+}
+
+void test02()
+{
+#if __cplusplus >= 201703L
+  // Can create initializer_list<X> with C++17 guaranteed copy elision,
+  // but shouldn't be able to copy from it with uninitialized_copy:
+  std::vector<X> v3{X{}, X{}, X{}};   // { dg-error "here" }
+#endif
+}
+// { dg-error "constructible from value" "" { target *-*-* } 0 }
+// { dg-error "constructible from input" "" { target *-*-* } 0 }
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_assign" }
 
 #include <vector>
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_insert" }
 
 #include <vector>
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_1_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_1_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_1_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <vector>
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_2_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_2_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/constructor_2_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <vector>
Index: libstdc++-v3/testsuite/23_containers/unordered_set/allocator/ext_ptr.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_set/allocator/ext_ptr.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/unordered_set/allocator/ext_ptr.cc	(.../branches/gcc-9-branch)
@@ -15,7 +15,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// { dg-do compile { target c++11 } }
+// { dg-do run { target { c++11_only || c++14_only } } }
+// { dg-do compile { target c++17 } }
 
 #include <unordered_set>
 #include <memory>
Index: libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/assign_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/assign_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/assign_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_assign" }
 
 #include <deque>
Index: libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/insert_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/insert_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/insert_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_insert" }
 
 #include <deque>
Index: libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_1_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_1_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_1_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <deque>
Index: libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_2_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_2_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/deque/requirements/dr438/constructor_2_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <deque>
Index: libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_assign" }
 
 #include <list>
Index: libstdc++-v3/testsuite/23_containers/list/requirements/dr438/insert_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/requirements/dr438/insert_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/list/requirements/dr438/insert_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <list>
Index: libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_1_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_1_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_1_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <list>
Index: libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_2_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_2_neg.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/23_containers/list/requirements/dr438/constructor_2_neg.cc	(.../branches/gcc-9-branch)
@@ -18,6 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
+// { dg-prune-output "cannot convert" }
 // { dg-prune-output "no matching function .*_M_fill_initialize" }
 
 #include <list>
Index: libstdc++-v3/testsuite/27_io/filesystem/iterators/91067.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/filesystem/iterators/91067.cc	(.../tags/gcc_9_2_0_release)
+++ libstdc++-v3/testsuite/27_io/filesystem/iterators/91067.cc	(.../branches/gcc-9-branch)
@@ -37,9 +37,25 @@
   d = std::move(d);
 }
 
+void
+test03()
+{
+  std::filesystem::directory_iterator d;
+  auto d2 = std::move(d);
+}
+
+void
+test04()
+{
+  std::filesystem::recursive_directory_iterator d;
+  auto d2 = std::move(d);
+}
+
 int
 main()
 {
   test01();
   test02();
+  test03();
+  test04();
 }
Index: libstdc++-v3/testsuite/26_numerics/transform_inclusive_scan/1.cc
===================================================================
--- libstdc++-v3/testsuite/26_numerics/transform_inclusive_scan/1.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/26_numerics/transform_inclusive_scan/1.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,94 @@
+// { dg-options "-std=gnu++17" }
+// { dg-do run { target c++17 } }
+
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// C++17 29.8.10 [transform.inclusive.scan]
+
+#include <numeric>
+#include <iterator>
+#include <testsuite_hooks.h>
+#include <testsuite_iterators.h>
+
+int a[] = {1, 2, 3, 4, 5, 6, 7};
+
+using __gnu_test::test_container;
+using __gnu_test::input_iterator_wrapper;
+using __gnu_test::output_iterator_wrapper;
+
+/*
+template<class InputIterator, class OutputIterator, class BinaryOperation,
+	 class UnaryOperation>
+  OutputIterator
+  transform_inclusive_scan(InputIterator, InputIterator, OutputIterator,
+			   BinaryOperation, UnaryOperation);
+*/
+void
+test01()
+{
+  int out[7];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::transform_inclusive_scan(ca.begin(), ca.end(), co.begin(),
+					   std::multiplies<>(),
+					   [](int i) { return i+1; });
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+7 );
+  VERIFY( out[0] == 2 );
+  VERIFY( out[1] == (2*3) );
+  VERIFY( out[2] == (2*3*4) );
+  VERIFY( out[3] == (2*3*4*5) );
+  VERIFY( out[4] == (2*3*4*5*6) );
+  VERIFY( out[5] == (2*3*4*5*6*7) );
+  VERIFY( out[6] == (2*3*4*5*6*7*8) );
+}
+
+/*
+template<class InputIterator, class OutputIterator, class BinaryOperation,
+	 class UnaryOperation, class T>
+  OutputIterator
+  transform_inclusive_scan(InputIterator, InputIterator, OutputIterator,
+			   BinaryOperation, UnaryOperation, T);
+*/
+void
+test02()
+{
+  int out[7];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::transform_inclusive_scan(ca.begin(), ca.end(), co.begin(),
+					   std::multiplies<>(),
+					   [](int i) { return i+1; },
+					   3);
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+7 );
+  VERIFY( out[0] == 3*2 );
+  VERIFY( out[1] == (3*2*3) );
+  VERIFY( out[2] == (3*2*3*4) );
+  VERIFY( out[3] == (3*2*3*4*5) );
+  VERIFY( out[4] == (3*2*3*4*5*6) );
+  VERIFY( out[5] == (3*2*3*4*5*6*7) );
+  VERIFY( out[6] == (3*2*3*4*5*6*7*8) );
+}
+
+int
+main()
+{
+  test01();
+  test02();
+}
Index: libstdc++-v3/testsuite/26_numerics/transform_reduce/1.cc
===================================================================
--- libstdc++-v3/testsuite/26_numerics/transform_reduce/1.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/26_numerics/transform_reduce/1.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,109 @@
+// { dg-options "-std=gnu++17" }
+// { dg-do run { target c++17 } }
+
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// C++17 29.8.5 [transform.reduce]
+
+#include <numeric>
+#include <iterator>
+#include <testsuite_hooks.h>
+#include <testsuite_iterators.h>
+
+int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
+double b[] = {0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5};
+
+using __gnu_test::test_container;
+using __gnu_test::input_iterator_wrapper;
+
+/*
+template<class InputIterator1, class InputIterator2, class T>
+  T transform_reduce(InputIterator1, InputIterator1, InputIterator2, T);
+*/
+void
+test01()
+{
+  auto res = std::transform_reduce(std::begin(a), std::end(a), std::begin(b),
+				   1.0f);
+  static_assert(std::is_same_v<decltype(res), float>);
+  VERIFY( res == (float)(1 + 0.5 + 1 + 1.5 + 2 + 2.5 + 3 + 3.5 + 4 + 4.5 + 5) );
+
+  test_container<int, input_iterator_wrapper> ca(a);
+  test_container<double, input_iterator_wrapper> cb(b);
+
+  auto res2 = std::transform_reduce(ca.begin(), ca.end(), cb.begin(),
+				   1.0f);
+  static_assert(std::is_same_v<decltype(res2), float>);
+  VERIFY( res2 == res );
+}
+
+/*
+template<class InputIterator1, class InputIterator2, class T,
+	 class BinaryOperation1, class BinaryOperation2>
+  T transform_reduce(InputIterator1, InputIterator1, InputIterator2, T,
+		     BinaryOperation1, BinaryOperation2);
+*/
+void
+test02()
+{
+  auto res = std::transform_reduce(std::begin(a), std::end(a), std::begin(b),
+				    1L, std::multiplies<>(), std::plus<int>());
+  static_assert(std::is_same_v<decltype(res), long>);
+  VERIFY( res == (1L * 1 * 2 * 3 * 4 * 5 * 6 * 7 * 8 * 9 * 10) );
+
+  test_container<int, input_iterator_wrapper> ca(a);
+  test_container<double, input_iterator_wrapper> cb(b);
+
+  auto res2 = std::transform_reduce(ca.begin(), ca.end(), cb.begin(),
+				    1L, std::multiplies<>(), std::plus<int>());
+  static_assert(std::is_same_v<decltype(res2), long>);
+  VERIFY( res2 == res );
+}
+
+/*
+template<class InputIterator, class T, class BinaryOperation,
+	 class UnaryOperation>
+  T transform_reduce(InputIterator, InputIterator, T,
+		     BinaryOperation, UnaryOperation);
+*/
+void
+test03()
+{
+  auto res = std::transform_reduce(std::begin(a), std::end(a), 10.0,
+				   std::plus<>(),
+				   [](int i) { return i * i; });
+  static_assert(std::is_same_v<decltype(res), double>);
+  VERIFY( res == (10.0 + 1 + 4 + 9 + 16 + 25 + 36 + 49 + 64 + 81 + 100) );
+
+  test_container<int, input_iterator_wrapper> ca(a);
+  test_container<double, input_iterator_wrapper> cb(b);
+
+  auto res2 = std::transform_reduce(ca.begin(), ca.end(), 10.0,
+				   std::plus<>(),
+				   [](int i) { return i * i; });
+  static_assert(std::is_same_v<decltype(res2), double>);
+  VERIFY( res2 == (10.0 + 1 + 4 + 9 + 16 + 25 + 36 + 49 + 64 + 81 + 100) );
+}
+
+int
+main()
+{
+  test01();
+  test02();
+  test03();
+}
Index: libstdc++-v3/testsuite/26_numerics/inclusive_scan/1.cc
===================================================================
--- libstdc++-v3/testsuite/26_numerics/inclusive_scan/1.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/26_numerics/inclusive_scan/1.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,123 @@
+// { dg-options "-std=gnu++17" }
+// { dg-do run { target c++17 } }
+
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// C++17 29.8.8 [inclusive.scan]
+
+#include <numeric>
+#include <iterator>
+#include <testsuite_hooks.h>
+#include <testsuite_iterators.h>
+
+int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
+
+using __gnu_test::test_container;
+using __gnu_test::input_iterator_wrapper;
+using __gnu_test::output_iterator_wrapper;
+
+/*
+template<class InputIterator, class OutputIterator>
+  OutputIterator
+  inclusive_scan(InputIterator, InputIterator, OutputIterator);
+*/
+void
+test01()
+{
+  int out[10];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::inclusive_scan(ca.begin(), ca.end(), co.begin());
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+10 );
+  VERIFY( out[0] == 1 );
+  VERIFY( out[1] == (1+2) );
+  VERIFY( out[2] == (1+2+3) );
+  VERIFY( out[3] == (1+2+3+4) );
+  VERIFY( out[4] == (1+2+3+4+5) );
+  VERIFY( out[5] == (1+2+3+4+5+6) );
+  VERIFY( out[6] == (1+2+3+4+5+6+7) );
+  VERIFY( out[7] == (1+2+3+4+5+6+7+8) );
+  VERIFY( out[8] == (1+2+3+4+5+6+7+8+9) );
+  VERIFY( out[9] == (1+2+3+4+5+6+7+8+9+10) );
+}
+
+/*
+template<class InputIterator, class OutputIterator, class BinaryOperation>
+  OutputIterator
+  inclusive_scan(InputIterator, InputIterator, OutputIterator,
+		 BinaryOperation);
+*/
+void
+test02()
+{
+  int out[10];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::inclusive_scan(ca.begin(), ca.end(), co.begin(),
+				 [](int i, int j) { return 2*i + 2*j; });
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+10 );
+  VERIFY( out[0] == 1 );
+  VERIFY( out[1] == (2*1+2*2) );
+  VERIFY( out[2] == (2*6+2*3) );
+  VERIFY( out[3] == (2*18+2*4) );
+  VERIFY( out[4] == (2*44+2*5) );
+  VERIFY( out[5] == (2*98+2*6));
+  VERIFY( out[6] == (2*208+2*7) );
+  VERIFY( out[7] == (2*430+2*8) );
+  VERIFY( out[8] == (2*876+2*9) );
+  VERIFY( out[9] == (2*1770+2*10) );
+}
+
+/*
+template<class InputIterator, class OutputIterator, class BinaryOperation, T>
+  OutputIterator
+  inclusive_scan(InputIterator, InputIterator, OutputIterator,
+		 BinaryOperation, T);
+*/
+void
+test03()
+{
+  int out[10];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::inclusive_scan(ca.begin(), ca.end(), co.begin(),
+				 [](int i, int j) { return 2*i + 2*j; },
+				 1);
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+10 );
+  VERIFY( out[0] == 4 );
+  VERIFY( out[1] == (2*4+2*2) );
+  VERIFY( out[2] == (2*12+2*3) );
+  VERIFY( out[3] == (2*30+2*4) );
+  VERIFY( out[4] == (2*68+2*5) );
+  VERIFY( out[5] == (2*146+2*6) );
+  VERIFY( out[6] == (2*304+2*7));
+  VERIFY( out[7] == (2*622+2*8) );
+  VERIFY( out[8] == (2*1260+2*9) );
+  VERIFY( out[9] == (2*2538+2*10) );
+}
+
+int
+main()
+{
+  test01();
+  test02();
+  test03();
+}
Index: libstdc++-v3/testsuite/26_numerics/transform_exclusive_scan/1.cc
===================================================================
--- libstdc++-v3/testsuite/26_numerics/transform_exclusive_scan/1.cc	(.../tags/gcc_9_2_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/26_numerics/transform_exclusive_scan/1.cc	(.../branches/gcc-9-branch)
@@ -0,0 +1,65 @@
+// { dg-options "-std=gnu++17" }
+// { dg-do run { target c++17 } }
+
+// Copyright (C) 2019 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// C++17 29.8.9 [transform.exclusive.scan]
+
+#include <numeric>
+#include <iterator>
+#include <testsuite_hooks.h>
+#include <testsuite_iterators.h>
+
+int a[] = {1, 2, 3, 4, 5, 6, 7};
+
+using __gnu_test::test_container;
+using __gnu_test::input_iterator_wrapper;
+using __gnu_test::output_iterator_wrapper;
+
+/*
+template<class InputIterator, class OutputIterator, class T,
+	 class BinaryOperation, class UnaryOperation>
+  OutputIterator
+  transform_exclusive_scan(InputIterator, InputIterator, OutputIterator, T,
+			   BinaryOperation, UnaryOperation);
+*/
+void
+test01()
+{
+  int out[7];
+  test_container<int, output_iterator_wrapper> co(out);
+  test_container<int, input_iterator_wrapper> ca(a);
+  auto end = std::transform_exclusive_scan(ca.begin(), ca.end(), co.begin(), 5,
+					   std::multiplies<>(),
+					   std::negate<>());
+  static_assert(std::is_same_v<decltype(end), decltype(co.begin())>);
+  VERIFY( end.ptr == out+7 );
+  VERIFY( out[0] == 5 );
+  VERIFY( out[1] == -5 );
+  VERIFY( out[2] == 10 );
+  VERIFY( out[3] == -30 );
+  VERIFY( out[4] == 120 );
+  VERIFY( out[5] == -600 );
+  VERIFY( out[6] == 3600 );
+}
+
+int
+main()
+{
+  test01();
+}
